cfg.mk 47.1 KB
Newer Older
1
# Customize Makefile.maint.                           -*- makefile -*-
M
Martin Kletzander 已提交
2
# Copyright (C) 2008-2015 Red Hat, Inc.
3
# Copyright (C) 2003-2008 Free Software Foundation, Inc.
4 5 6 7 8 9 10 11 12 13 14 15

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
16 17
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
18 19 20 21 22 23 24 25 26 27 28

# Use alpha.gnu.org for alpha and beta releases.
# Use ftp.gnu.org for major releases.
gnu_ftp_host-alpha = alpha.gnu.org
gnu_ftp_host-beta = alpha.gnu.org
gnu_ftp_host-major = ftp.gnu.org
gnu_rel_host = $(gnu_ftp_host-$(RELEASE_TYPE))

url_dir_list = \
  ftp://$(gnu_rel_host)/gnu/coreutils

29 30 31
# We use .gnulib, not gnulib.
gnulib_dir = $(srcdir)/.gnulib

E
Eric Blake 已提交
32 33 34
# List of additional files that we want to pick up in our POTFILES.in
# This is all gnulib files, as well as generated files for RPC code.
generated_files = \
35
  $(srcdir)/src/*/{remote_daemon,admin_server,log_daemon,lock_daemon}_dispatch_*stubs.h \
36
  $(srcdir)/src/lxc/{lxc_monitor,lxc_controller}_dispatch.h \
E
Eric Blake 已提交
37
  $(srcdir)/src/remote/*_client_bodies.h \
E
Eric Blake 已提交
38
  $(srcdir)/src/*/*_protocol.[ch] \
E
Eric Blake 已提交
39 40
  $(srcdir)/gnulib/lib/*.[ch]

E
Eric Blake 已提交
41 42 43
# We haven't converted all scripts to using gnulib's init.sh yet.
_test_script_regex = \<\(init\|test-lib\)\.sh\>

44
# Tests not to run as part of "make distcheck".
45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78
local-checks-to-skip = \
  changelog-check \
  makefile-check \
  makefile_path_separator_check \
  patch-check \
  sc_GPL_version \
  sc_always_defined_macros \
  sc_cast_of_alloca_return_value \
  sc_cross_check_PATH_usage_in_tests \
  sc_dd_max_sym_length \
  sc_error_exit_success \
  sc_file_system \
  sc_immutable_NEWS \
  sc_makefile_path_separator_check \
  sc_obsolete_symbols \
  sc_prohibit_S_IS_definition \
  sc_prohibit_atoi_atof \
  sc_prohibit_hash_without_use \
  sc_prohibit_jm_in_m4 \
  sc_prohibit_quote_without_use \
  sc_prohibit_quotearg_without_use \
  sc_prohibit_stat_st_blocks \
  sc_prohibit_undesirable_word_seq \
  sc_root_tests \
  sc_space_tab \
  sc_sun_os_names \
  sc_system_h_headers \
  sc_texinfo_acronym \
  sc_tight_scope \
  sc_two_space_separator_in_usage \
  sc_error_message_uppercase \
  sc_program_name \
  sc_require_test_exit_idiom \
  sc_makefile_check \
79
  sc_useless_cpp_parens
80

81 82 83 84 85 86 87 88
# Most developers don't run 'make distcheck'.  We want the official
# dist to be secure, but don't want to penalize other developers
# using a distro that has not yet picked up the automake fix.
# FIXME remove this ifeq (making the syntax check unconditional)
# once fixed automake (1.11.6 or 1.12.2+) is more common.
ifeq ($(filter dist%, $(MAKECMDGOALS)), )
local-checks-to-skip +=	sc_vulnerable_makefile_CVE-2012-3386
else
89
distdir: sc_vulnerable_makefile_CVE-2012-3386.z
90 91
endif

92
# Files that should never cause syntax check failures.
93
VC_LIST_ALWAYS_EXCLUDE_REGEX = \
94
  (^(docs/(news(-[0-9]*)?\.html\.in|.*\.patch))|\.(po|fig|gif|ico|png))$$
95 96

# Functions like free() that are no-ops on NULL arguments.
97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181
useless_free_options = \
  --name=VBOX_UTF16_FREE \
  --name=VBOX_UTF8_FREE \
  --name=VBOX_COM_UNALLOC_MEM \
  --name=VIR_FREE \
  --name=qemuCapsFree \
  --name=qemuMigrationCookieFree \
  --name=qemuMigrationCookieGraphicsFree \
  --name=sexpr_free \
  --name=usbFreeDevice \
  --name=virBandwidthDefFree \
  --name=virBitmapFree \
  --name=virCPUDefFree \
  --name=virCapabilitiesFree \
  --name=virCapabilitiesFreeGuest \
  --name=virCapabilitiesFreeGuestDomain \
  --name=virCapabilitiesFreeGuestFeature \
  --name=virCapabilitiesFreeGuestMachine \
  --name=virCapabilitiesFreeHostNUMACell \
  --name=virCapabilitiesFreeMachines \
  --name=virCgroupFree \
  --name=virCommandFree \
  --name=virConfFreeList \
  --name=virConfFreeValue \
  --name=virDomainActualNetDefFree \
  --name=virDomainChrDefFree \
  --name=virDomainChrSourceDefFree \
  --name=virDomainControllerDefFree \
  --name=virDomainDefFree \
  --name=virDomainDeviceDefFree \
  --name=virDomainDiskDefFree \
  --name=virDomainEventCallbackListFree \
  --name=virObjectEventQueueFree \
  --name=virDomainFSDefFree \
  --name=virDomainGraphicsDefFree \
  --name=virDomainHostdevDefFree \
  --name=virDomainInputDefFree \
  --name=virDomainNetDefFree \
  --name=virDomainObjFree \
  --name=virDomainSmartcardDefFree \
  --name=virDomainSnapshotDefFree \
  --name=virDomainSnapshotObjFree \
  --name=virDomainSoundDefFree \
  --name=virDomainVideoDefFree \
  --name=virDomainWatchdogDefFree \
  --name=virFileDirectFdFree \
  --name=virHashFree \
  --name=virInterfaceDefFree \
  --name=virInterfaceIpDefFree \
  --name=virInterfaceObjFree \
  --name=virInterfaceProtocolDefFree \
  --name=virJSONValueFree \
  --name=virLastErrFreeData \
  --name=virNetMessageFree \
  --name=virNetServerMDNSFree \
  --name=virNetServerMDNSEntryFree \
  --name=virNetServerMDNSGroupFree \
  --name=virNWFilterDefFree \
  --name=virNWFilterEntryFree \
  --name=virNWFilterHashTableFree \
  --name=virNWFilterIPAddrLearnReqFree \
  --name=virNWFilterIncludeDefFree \
  --name=virNWFilterObjFree \
  --name=virNWFilterRuleDefFree \
  --name=virNWFilterRuleInstFree \
  --name=virNetworkDefFree \
  --name=virNodeDeviceDefFree \
  --name=virNodeDeviceObjFree \
  --name=virObjectUnref \
  --name=virObjectFreeCallback \
  --name=virPCIDeviceFree \
  --name=virSecretDefFree \
  --name=virStorageEncryptionFree \
  --name=virStorageEncryptionSecretFree \
  --name=virStorageFileFreeMetadata \
  --name=virStoragePoolDefFree \
  --name=virStoragePoolObjFree \
  --name=virStoragePoolSourceFree \
  --name=virStorageVolDefFree \
  --name=virThreadPoolFree \
  --name=xmlBufferFree \
  --name=xmlFree \
  --name=xmlFreeDoc \
  --name=xmlFreeNode \
  --name=xmlXPathFreeContext \
182
  --name=xmlXPathFreeObject
183

184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223
# The following template was generated by this command:
# make ID && aid free|grep '^vi'|sed 's/ .*//;s/^/#   /'
# N virBufferFreeAndReset
# y virCPUDefFree
# y virCapabilitiesFree
# y virCapabilitiesFreeGuest
# y virCapabilitiesFreeGuestDomain
# y virCapabilitiesFreeGuestFeature
# y virCapabilitiesFreeGuestMachine
# y virCapabilitiesFreeHostNUMACell
# y virCapabilitiesFreeMachines
# N virCapabilitiesFreeNUMAInfo FIXME
# y virCgroupFree
# N virConfFree               (diagnoses the "error")
# y virConfFreeList
# y virConfFreeValue
# y virDomainChrDefFree
# y virDomainControllerDefFree
# y virDomainDefFree
# y virDomainDeviceDefFree
# y virDomainDiskDefFree
# y virDomainEventCallbackListFree
# y virDomainEventQueueFree
# y virDomainFSDefFree
# n virDomainFree
# n virDomainFreeName (can't fix -- returns int)
# y virDomainGraphicsDefFree
# y virDomainHostdevDefFree
# y virDomainInputDefFree
# y virDomainNetDefFree
# y virDomainObjFree
# y virDomainSnapshotDefFree
# n virDomainSnapshotFree (returns int)
# n virDomainSnapshotFreeName (returns int)
# y virDomainSnapshotObjFree
# y virDomainSoundDefFree
# y virDomainVideoDefFree
# y virDomainWatchdogDefFree
# n virDrvNodeGetCellsFreeMemory (returns int)
# n virDrvNodeGetFreeMemory (returns long long)
E
Eric Blake 已提交
224
# n virFree - dereferences param
225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241
# n virFreeError
# n virHashFree (takes 2 args)
# y virInterfaceDefFree
# n virInterfaceFree (returns int)
# n virInterfaceFreeName
# y virInterfaceIpDefFree
# y virInterfaceObjFree
# n virInterfaceObjListFree
# y virInterfaceProtocolDefFree
# y virJSONValueFree
# y virLastErrFreeData
# y virNWFilterDefFree
# y virNWFilterEntryFree
# n virNWFilterFree (returns int)
# y virNWFilterHashTableFree
# y virNWFilterIPAddrLearnReqFree
# y virNWFilterIncludeDefFree
242 243 244
# n virNWFilterFreeName (returns int)
# y virNWFilterObjFree
# n virNWFilterObjListFree FIXME
245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276
# y virNWFilterRuleDefFree
# n virNWFilterRuleFreeInstanceData (typedef)
# y virNWFilterRuleInstFree
# y virNetworkDefFree
# n virNetworkFree (returns int)
# n virNetworkFreeName (returns int)
# n virNodeDevCapsDefFree FIXME
# y virNodeDeviceDefFree
# n virNodeDeviceFree (returns int)
# y virNodeDeviceObjFree
# n virNodeDeviceObjListFree FIXME
# n virNodeGetCellsFreeMemory (returns int)
# n virNodeGetFreeMemory (returns non-void)
# y virSecretDefFree
# n virSecretFree (returns non-void)
# n virSecretFreeName (2 args)
# n virSecurityLabelDefFree FIXME
# n virStorageBackendDiskMakeFreeExtent (returns non-void)
# y virStorageEncryptionFree
# y virStorageEncryptionSecretFree
# n virStorageFreeType (enum)
# y virStoragePoolDefFree
# n virStoragePoolFree (returns non-void)
# n virStoragePoolFreeName (returns non-void)
# y virStoragePoolObjFree
# n virStoragePoolObjListFree FIXME
# y virStoragePoolSourceFree
# y virStorageVolDefFree
# n virStorageVolFree (returns non-void)
# n virStorageVolFreeName (returns non-void)
# n virStreamFree

277 278 279
# Avoid uses of write(2).  Either switch to streams (fwrite), or use
# the safewrite wrapper.
sc_avoid_write:
280 281 282
	@prohibit='\<write *\(' \
	in_vc_files='\.c$$' \
	halt='consider using safewrite instead of write' \
283
	  $(_sc_search_regexp)
284

285 286
# In debug statements, print flags as bitmask and mode_t as octal.
sc_flags_debug:
287 288
	@prohibit='\<mode=%[0-9.]*[diuxo]' \
	halt='use \"0%o\" to debug mode_t values' \
289
	  $(_sc_search_regexp)
290 291
	@prohibit='[Ff]lags=%[0-9.]*l*[dioux]' \
	halt='use \"0x%x\" to debug flag values' \
292 293 294 295 296 297 298 299 300 301 302
	  $(_sc_search_regexp)

# Prefer 'unsigned int flags', along with checks for unknown flags.
# For historical reasons, we are stuck with 'unsigned long flags' in
# migration, so check for those known 4 instances and no more in public
# API.  Also check that no flags are marked unused, and 'unsigned' should
# appear before any declaration of a flags variable (achieved by
# prohibiting the word prior to the type from ending in anything other
# than d).  The existence of long long, and of documentation about
# flags, makes the regex in the third test slightly harder.
sc_flags_usage:
303 304 305 306 307 308 309
	@test "$$(cat $(srcdir)/include/libvirt/libvirt-domain.h \
	    $(srcdir)/include/libvirt/virterror.h \
	    $(srcdir)/include/libvirt/libvirt-qemu.h \
	    $(srcdir)/include/libvirt/libvirt-lxc.h \
	    $(srcdir)/include/libvirt/libvirt-admin.h \
	  | grep -c '\(long\|unsigned\) flags')" != 4 && \
	  { echo '$(ME): new API should use "unsigned int flags"' 1>&2; \
310
	    exit 1; } || :
311 312
	@prohibit=' flags ATTRIBUTE_UNUSED' \
	halt='flags should be checked with virCheckFlags' \
313
	  $(_sc_search_regexp)
314 315
	@prohibit='^[^@]*([^d] (int|long long)|[^dg] long) flags[;,)]' \
	halt='flags should be unsigned' \
316 317
	  $(_sc_search_regexp)

E
Eric Blake 已提交
318 319
# Avoid functions that should only be called via macro counterparts.
sc_prohibit_internal_functions:
320
	@prohibit='vir(Free|AllocN?|ReallocN|(Insert|Delete)ElementsN|File(Close|Fclose|Fdopen)) *\(' \
321
	halt='use VIR_ macros instead of internal functions' \
E
Eric Blake 已提交
322 323
	  $(_sc_search_regexp)

324 325 326 327 328
sc_prohibit_raw_virclassnew:
	@prohibit='virClassNew *\(' \
	halt='use VIR_CLASS_NEW instead of virClassNew' \
	  $(_sc_search_regexp)

E
Eric Blake 已提交
329 330
# Avoid raw malloc and free, except in documentation comments.
sc_prohibit_raw_allocation:
331 332
	@prohibit='^.[^*].*\<((m|c|re)alloc|free) *\([^)]' \
	halt='use VIR_ macros from viralloc.h instead of malloc/free' \
E
Eric Blake 已提交
333 334
	  $(_sc_search_regexp)

E
Eric Blake 已提交
335 336
# Avoid functions that can lead to double-close bugs.
sc_prohibit_close:
337 338
	@prohibit='([^>.]|^)\<[fp]?close *\(' \
	halt='use VIR_{FORCE_}[F]CLOSE instead of [f]close' \
E
Eric Blake 已提交
339
	  $(_sc_search_regexp)
340 341
	@prohibit='\<fdopen *\(' \
	halt='use VIR_FDOPEN instead of fdopen' \
E
Eric Blake 已提交
342 343
	  $(_sc_search_regexp)

344 345
# Prefer virCommand for all child processes.
sc_prohibit_fork_wrappers:
346 347
	@prohibit='= *\<(fork|popen|system) *\(' \
	halt='use virCommand for child processes' \
348 349
	  $(_sc_search_regexp)

350 351
# Prefer mkostemp with O_CLOEXEC.
sc_prohibit_mkstemp:
352 353
	@prohibit='[^"]\<mkstemps? *\(' \
	halt='use mkostemp with O_CLOEXEC instead of mkstemp' \
354 355
	  $(_sc_search_regexp)

E
Eric Blake 已提交
356 357 358
# access with X_OK accepts directories, but we can't exec() those.
# access with F_OK or R_OK is okay, though.
sc_prohibit_access_xok:
359 360
	@prohibit='access(at)? *\(.*X_OK' \
	halt='use virFileIsExecutable instead of access(,X_OK)' \
E
Eric Blake 已提交
361 362
	  $(_sc_search_regexp)

E
Eric Blake 已提交
363 364
# Similar to the gnulib maint.mk rule for sc_prohibit_strcmp
# Use STREQLEN or STRPREFIX rather than comparing strncmp == 0, or != 0.
E
Eric Blake 已提交
365
snp_ = strncmp *\(.+\)
E
Eric Blake 已提交
366
sc_prohibit_strncmp:
367 368 369
	@prohibit='! *strncmp *\(|\<$(snp_) *[!=]=|[!=]= *$(snp_)' \
	exclude=':# *define STR(N?EQLEN|PREFIX)\(' \
	halt='use STREQLEN or STRPREFIX instead of strncmp' \
E
Eric Blake 已提交
370
	  $(_sc_search_regexp)
371

E
Eric Blake 已提交
372 373
# strtol and friends are too easy to misuse
sc_prohibit_strtol:
374 375 376
	@prohibit='\bstrto(u?ll?|[ui]max) *\(' \
	exclude='exempt from syntax-check' \
	halt='use virStrToLong_*, not strtol variants' \
E
Eric Blake 已提交
377
	  $(_sc_search_regexp)
378 379 380
	@prohibit='\bstrto[df] *\(' \
	exclude='exempt from syntax-check' \
	halt='use virStrToDouble, not strtod variants' \
E
Eric Blake 已提交
381 382
	  $(_sc_search_regexp)

E
Eric Blake 已提交
383
# Use virAsprintf rather than as'printf since *strp is undefined on error.
E
Eric Blake 已提交
384
# But for plain %s, virAsprintf is overkill compared to strdup.
385
sc_prohibit_asprintf:
386 387
	@prohibit='\<v?a[s]printf\>' \
	halt='use virAsprintf, not asprintf' \
E
Eric Blake 已提交
388
	  $(_sc_search_regexp)
389 390
	@prohibit='virAsprintf.*, *"%s",' \
	halt='use VIR_STRDUP instead of virAsprintf with "%s"' \
391 392 393
	  $(_sc_search_regexp)

sc_prohibit_strdup:
394 395
	@prohibit='\<strn?dup\> *\(' \
	halt='use VIR_STRDUP, not strdup' \
E
Eric Blake 已提交
396
	  $(_sc_search_regexp)
E
Eric Blake 已提交
397

E
Eric Blake 已提交
398 399
# Prefer virSetUIDGID.
sc_prohibit_setuid:
400 401
	@prohibit='\<set(re)?[ug]id\> *\(' \
	halt='use virSetUIDGID, not raw set*id' \
E
Eric Blake 已提交
402 403
	  $(_sc_search_regexp)

404 405
# Don't compare *id_t against raw -1.
sc_prohibit_risky_id_promotion:
406 407
	@prohibit='\b(user|group|[ug]id) *[=!]= *-' \
	halt='cast -1 to ([ug]id_t) before comparing against id' \
408 409
	  $(_sc_search_regexp)

E
Eric Blake 已提交
410 411 412
# Use snprintf rather than s'printf, even if buffer is provably large enough,
# since gnulib has more guarantees for snprintf portability
sc_prohibit_sprintf:
413 414
	@prohibit='\<[s]printf\>' \
	halt='use snprintf, not sprintf' \
E
Eric Blake 已提交
415
	  $(_sc_search_regexp)
416

417
sc_prohibit_readlink:
418 419
	@prohibit='\<readlink *\(' \
	halt='use virFileResolveLink, not readlink' \
E
Eric Blake 已提交
420
	  $(_sc_search_regexp)
421

422
sc_prohibit_gethostname:
423 424
	@prohibit='gethostname *\(' \
	halt='use virGetHostname, not gethostname' \
E
Eric Blake 已提交
425
	  $(_sc_search_regexp)
426

E
Eric Blake 已提交
427
sc_prohibit_readdir:
428 429 430
	@prohibit='\b(read|close|open)dir *\(' \
	exclude='exempt from syntax-check' \
	halt='use virDirOpen, virDirRead and VIR_DIR_CLOSE' \
E
Eric Blake 已提交
431 432
	  $(_sc_search_regexp)

E
Eric Blake 已提交
433
sc_prohibit_gettext_noop:
434 435
	@prohibit='gettext_noop *\(' \
	halt='use N_, not gettext_noop' \
E
Eric Blake 已提交
436
	  $(_sc_search_regexp)
E
Eric Blake 已提交
437

438
sc_prohibit_VIR_ERR_NO_MEMORY:
439 440
	@prohibit='\<VIR_ERR_NO_MEMORY\>' \
	halt='use virReportOOMError, not VIR_ERR_NO_MEMORY' \
E
Eric Blake 已提交
441
	  $(_sc_search_regexp)
442

443
sc_prohibit_PATH_MAX:
444 445
	@prohibit='\<PATH_MAX\>' \
	halt='dynamically allocate paths, do not use PATH_MAX' \
446 447
	  $(_sc_search_regexp)

448
include $(srcdir)/Makefile.nonreentrant
449
sc_prohibit_nonreentrant:
450 451
	@prohibit="\\<(${NON_REENTRANT_RE}) *\\(" \
	halt="use re-entrant functions (usually ending with _r)" \
452
	  $(_sc_search_regexp)
453

454
sc_prohibit_select:
455 456
	@prohibit='\<select *\(' \
	halt='use poll(), not select()' \
457 458
	  $(_sc_search_regexp)

459 460
# Prohibit the inclusion of <ctype.h>.
sc_prohibit_ctype_h:
461 462
	@prohibit='^# *include  *<ctype\.h>' \
	halt='use c-ctype.h instead of ctype.h' \
463
	  $(_sc_search_regexp)
464

465 466 467 468 469 470 471
# We have our own wrapper for mocking purposes
sc_prohibit_canonicalize_file_name:
	@prohibit='\<canonicalize_file_name\(' \
	exclude='exempt from syntax-check' \
	halt='use virFileCanonicalizePath() instead of canonicalize_file_name()' \
	  $(_sc_search_regexp)

472 473
# Insist on correct types for [pug]id.
sc_correct_id_types:
474
	@prohibit='\<(int|long) *[pug]id\>' \
475
	exclude='exempt from syntax-check' \
476
	halt='use pid_t for pid, uid_t for uid, gid_t for gid' \
477 478
	  $(_sc_search_regexp)

479 480 481
# "const fooPtr a" is the same as "foo * const a", even though it is
# usually desired to have "foo const *a".  It's easier to just prevent
# the confusing mix of typedef vs. const placement.
482
# Also requires that all 'fooPtr' typedefs are actually pointers.
483
sc_forbid_const_pointer_typedef:
484 485
	@prohibit='(^|[^"])const \w*Ptr' \
	halt='"const fooPtr var" does not declare what you meant' \
486
	  $(_sc_search_regexp)
487 488
	@prohibit='typedef [^(]+ [^*]\w*Ptr\b' \
	halt='use correct style and type for Ptr typedefs' \
489
	  $(_sc_search_regexp)
490

491 492
# Forbid sizeof foo or sizeof (foo), require sizeof(foo)
sc_size_of_brackets:
493 494
	@prohibit='sizeof\s' \
	halt='use sizeof(foo), not sizeof (foo) or sizeof foo' \
495 496
	  $(_sc_search_regexp)

E
Eric Blake 已提交
497
# Ensure that no C source file, docs, or rng schema uses TABs for
D
David Allan 已提交
498 499
# indentation.  Also match *.h.in files, to get libvirt.h.in.  Exclude
# files in gnulib, since they're imported.
500
space_indent_files=(\.(aug(\.in)?|rng|s?[ch](\.in)?|html.in|py|pl|syms)|(daemon|tools)/.*\.in)
501
sc_TAB_in_indentation:
502 503
	@prohibit='^ *	' \
	in_vc_files='$(space_indent_files)$$' \
504
	halt='indent with space, not TAB, in C, sh, html, py, syms and RNG schemas' \
505
	  $(_sc_search_regexp)
506 507 508 509 510

ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper

sc_avoid_ctype_macros:
511
	@prohibit='\b($(ctype_re)) *\(' \
512
	in_vc_files='\.[ch]$$' \
513
	halt='use c-ctype.h instead of ctype macros' \
514
	  $(_sc_search_regexp)
515

516
sc_avoid_strcase:
517 518
	@prohibit='\bstrn?case(cmp|str) *\(' \
	halt='use c-strcase.h instead of raw strcase functions' \
519 520
	  $(_sc_search_regexp)

521
sc_prohibit_virBufferAdd_with_string_literal:
522
	@prohibit='\<virBufferAdd *\([^,]+, *"[^"]' \
E
Eric Blake 已提交
523 524
	halt='use virBufferAddLit, not virBufferAdd, with a string literal' \
	  $(_sc_search_regexp)
525

526
sc_prohibit_virBufferAsprintf_with_string_literal:
527
	@prohibit='\<virBufferAsprintf *\([^,]+, *"([^%"\]|\\.|%%)*"\)' \
528 529 530
	halt='use virBufferAddLit, not virBufferAsprintf, with a string literal' \
	  $(_sc_search_regexp)

531
sc_forbid_manual_xml_indent:
532
	@prohibit='virBuffer.*" +<' \
533 534 535
	halt='use virBufferAdjustIndent instead of spaces when indenting xml' \
	  $(_sc_search_regexp)

536 537
# dirname and basename from <libgen.h> are not required to be thread-safe
sc_prohibit_libgen:
538 539
	@prohibit='( (base|dir)name *\(|include .libgen\.h)' \
	halt='use functions from gnulib "dirname.h", not <libgen.h>' \
540 541
	  $(_sc_search_regexp)

542 543
# raw xmlGetProp requires some nasty casts
sc_prohibit_xmlGetProp:
544 545
	@prohibit='\<xmlGetProp *\(' \
	halt='use virXMLPropString, not xmlGetProp' \
546 547
	  $(_sc_search_regexp)

M
Martin Kletzander 已提交
548 549
# xml(ParseURI|SaveUri) doesn't handle IPv6 URIs well
sc_prohibit_xmlURI:
550 551
	@prohibit='\<xml(ParseURI|SaveUri) *\(' \
	halt='use virURI(Parse|Format), not xml(ParseURI|SaveUri)' \
M
Martin Kletzander 已提交
552 553
	  $(_sc_search_regexp)

554 555
# we don't want old old-style return with parentheses around argument
sc_prohibit_return_as_function:
556 557
	@prohibit='\<return *\(([^()]*(\([^()]*\)[^()]*)*)\) *;' \
	halt='avoid extra () with return statements' \
558 559
	  $(_sc_search_regexp)

560 561 562
# ATTRIBUTE_UNUSED should only be applied in implementations, not
# header declarations
sc_avoid_attribute_unused_in_header:
563 564 565
	@prohibit='^[^#]*ATTRIBUTE_UNUSED([^:]|$$)' \
	in_vc_files='\.h$$' \
	halt='use ATTRIBUTE_UNUSED in .c rather than .h files' \
566 567
	  $(_sc_search_regexp)

568
sc_prohibit_int_index:
569 570
	@prohibit='\<(int|unsigned)\s*\*?index\>(\s|,|;)' \
	halt='use different name than 'index' for declaration' \
571 572
	  $(_sc_search_regexp)

573
sc_prohibit_int_ijk:
574 575 576
	@prohibit='\<(int|unsigned) ([^(=]* )*(i|j|k)\>(\s|,|;)' \
	exclude='exempt from syntax-check' \
	halt='use size_t, not int/unsigned int for loop vars i, j, k' \
577 578 579
	  $(_sc_search_regexp)

sc_prohibit_loop_iijjkk:
580 581
	@prohibit='\<(int|unsigned) ([^=]+ )*(ii|jj|kk)\>(\s|,|;)' \
	halt='use i, j, k for loop iterators, not ii, jj, kk' \
582 583
	  $(_sc_search_regexp)

E
Eric Blake 已提交
584 585
# RHEL 5 gcc can't grok "for (int i..."
sc_prohibit_loop_var_decl:
586 587 588
	@prohibit='\<for *\(\w+[ *]+\w+' \
	in_vc_files='\.[ch]$$' \
	halt='declare loop iterators outside the for statement' \
E
Eric Blake 已提交
589
	  $(_sc_search_regexp)
E
Eric Blake 已提交
590 591 592

# Use 'bool', not 'int', when assigning true or false
sc_prohibit_int_assign_bool:
593 594
	@prohibit='\<int\>.*= *(true|false)' \
	halt='use bool type for boolean values' \
E
Eric Blake 已提交
595
	  $(_sc_search_regexp)
596

M
Michal Privoznik 已提交
597
sc_prohibit_unsigned_pid:
598 599
	@prohibit='\<unsigned\> [^,=;(]+pid' \
	halt='use signed type for pid values' \
M
Michal Privoznik 已提交
600 601
	  $(_sc_search_regexp)

602 603 604 605 606 607
# Many of the function names below came from this filter:
# git grep -B2 '\<_('|grep -E '\.c- *[[:alpha:]_][[:alnum:]_]* ?\(.*[,;]$' \
# |sed 's/.*\.c-  *//'|perl -pe 's/ ?\(.*//'|sort -u \
# |grep -vE '^(qsort|if|close|assert|fputc|free|N_|vir.*GetName|.*Unlock|virNodeListDevices|virHashRemoveEntry|freeaddrinfo|.*[fF]ree|xdrmem_create|xmlXPathFreeObject|virUUIDFormat|openvzSetProgramSentinal|polkit_action_unref)$'

msg_gen_function =
608
msg_gen_function += VIR_ERROR
609 610
msg_gen_function += lxcError
msg_gen_function += regerror
611 612
msg_gen_function += vah_error
msg_gen_function += vah_warning
613
msg_gen_function += virGenericReportError
614
msg_gen_function += virRaiseError
615
msg_gen_function += virReportError
616 617
msg_gen_function += virReportErrorHelper
msg_gen_function += virReportSystemError
618
msg_gen_function += xenapiSessionErrorHandler
619 620 621 622 623 624 625 626 627

# Uncomment the following and run "make syntax-check" to see diagnostics
# that are not yet marked for translation, but that need to be rewritten
# so that they are translatable.
# msg_gen_function += fprintf
# msg_gen_function += testError
# msg_gen_function += vshPrint
# msg_gen_function += vshError

J
Ján Tomko 已提交
628 629 630
space =
space +=
func_re= ($(subst $(space),|,$(msg_gen_function)))
631 632 633 634 635 636 637

# Look for diagnostics that aren't marked for translation.
# This won't find any for which error's format string is on a separate line.
# The sed filters eliminate false-positives like these:
#    _("...: "
#    "%s", _("no storage vol w..."
sc_libvirt_unmarked_diagnostics:
638 639 640
	@prohibit='\<$(func_re) *\([^"]*"[^"]*[a-z]{3}' \
	exclude='_\(' \
	halt='found unmarked diagnostic(s)' \
E
Eric Blake 已提交
641
	  $(_sc_search_regexp)
642
	@{ grep     -nE '\<$(func_re) *\(.*;$$' $$($(VC_LIST_EXCEPT)); \
643
	   grep -A1 -nE '\<$(func_re) *\(.*,$$' $$($(VC_LIST_EXCEPT)); } \
644 645 646
	   | $(SED) 's/_("\([^\"]\|\\.\)\+"//;s/[	 ]"%s"//' \
	   | grep '[	 ]"' && \
	  { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
647
	    exit 1; } || :
648

649 650 651 652 653 654 655 656
# Like the above, but prohibit a newline at the end of a diagnostic.
# This is subject to false positives partly because it naively looks for
# `\n"', which may not be the end of the string, and also because it takes
# two lines of context (the -A2) after the line with the function name.
# FIXME: this rule might benefit from a separate function list, in case
# there are functions to which this one applies but that do not get marked
# diagnostics.
sc_prohibit_newline_at_end_of_diagnostic:
657 658 659 660
	@grep -A2 -nE \
	    '\<$(func_re) *\(' $$($(VC_LIST_EXCEPT)) \
	    | grep '\\n"' \
	  && { echo '$(ME): newline at end of message(s)' 1>&2; \
661 662
	    exit 1; } || :

663 664 665 666
# Look for diagnostics that lack a % in the format string, except that we
# allow VIR_ERROR to do this, and ignore functions that take a single
# string rather than a format argument.
sc_prohibit_diagnostic_without_format:
667
	@{ grep     -nE '\<$(func_re) *\(.*;$$' $$($(VC_LIST_EXCEPT)); \
668
	   grep -A2 -nE '\<$(func_re) *\(.*,$$' $$($(VC_LIST_EXCEPT)); } \
669 670 671 672 673
	   | $(SED) -rn -e ':l; /[,"]$$/ {N;b l;}' \
		-e '/(xenapiSessionErrorHandler|vah_(error|warning))/d' \
		-e '/\<$(func_re) *\([^"]*"([^%"]|"\n[^"]*")*"[,)]/p' \
           | grep -vE 'VIR_ERROR' && \
	  { echo '$(ME): found diagnostic without %' 1>&2; \
674 675
	    exit 1; } || :

676
# The strings "" and "%s" should never be marked for translation.
677
# Files under tests/ and examples/ should not be translated.
678
sc_prohibit_useless_translation:
679 680
	@prohibit='_\("(%s)?"\)' \
	halt='found useless translation' \
681
	  $(_sc_search_regexp)
682 683 684
	@prohibit='\<N?_ *\(' \
	in_vc_files='(tests|examples)/' \
	halt='no translations in tests or examples' \
685 686
	  $(_sc_search_regexp)

687 688 689
# When splitting a diagnostic across lines, ensure that there is a space
# or \n on one side of the split.
sc_require_whitespace_in_translation:
690 691 692 693
	@grep -n -A1 '"$$' $$($(VC_LIST_EXCEPT)) \
	   | $(SED) -ne ':l; /"$$/ {N;b l;}; s/"\n[^"]*"/""/g; s/\\n/ /g' \
		-e '/_(.*[^\ ]""[^\ ]/p' | grep . && \
	  { echo '$(ME): missing whitespace at line split' 1>&2; \
694 695
	    exit 1; } || :

696 697
# Enforce recommended preprocessor indentation style.
sc_preprocessor_indentation:
698 699 700 701 702 703
	@if cppi --version >/dev/null 2>&1; then \
	  $(VC_LIST_EXCEPT) | grep -E '\.[ch](\.in)?$$' | xargs cppi -a -c \
	    || { echo '$(ME): incorrect preprocessor indentation' 1>&2; \
		exit 1; }; \
	else \
	  echo '$(ME): skipping test $@: cppi not installed' 1>&2; \
704 705
	fi

706 707 708
# Enforce similar spec file indentation style, by running cppi on a
# (comment-only) C file that mirrors the same layout as the spec file.
sc_spec_indentation:
709 710 711 712 713 714 715 716 717 718 719 720
	@if cppi --version >/dev/null 2>&1; then \
	  for f in $$($(VC_LIST_EXCEPT) | grep '\.spec\.in$$'); do \
	    $(SED) -e 's|#|// #|; s|%ifn*\(arch\)* |#if a // |' \
		-e 's/%\(else\|endif\|define\)/#\1/' \
		-e 's/^\( *\)\1\1\1#/#\1/' \
		-e 's|^\( *[^#/ ]\)|// \1|; s|^\( */[^/]\)|// \1|' $$f \
	    | cppi -a -c 2>&1 | $(SED) "s|standard input|$$f|"; \
	  done | { if grep . >&2; then false; else :; fi; } \
	    || { echo '$(ME): incorrect preprocessor indentation' 1>&2; \
		exit 1; }; \
	else \
	  echo '$(ME): skipping test $@: cppi not installed' 1>&2; \
721 722
	fi

723 724 725
# Nested conditionals are easier to understand if we enforce that endifs
# can be paired back to the if
sc_makefile_conditionals:
726 727 728
	@prohibit='(else|endif)($$| *#)' \
	in_vc_files='Makefile\.am' \
	halt='match "if FOO" with "endif FOO" in Makefiles' \
729 730
	  $(_sc_search_regexp)

E
Eric Blake 已提交
731 732 733 734
# Long lines can be harder to diff; too long, and git send-email chokes.
# For now, only enforce line length on files where we have intentionally
# fixed things and don't want to regress.
sc_prohibit_long_lines:
735 736 737
	@prohibit='.{90}' \
	in_vc_files='\.arg[sv]' \
	halt='Wrap long lines in expected output files' \
E
Eric Blake 已提交
738
	  $(_sc_search_regexp)
739 740 741
	@prohibit='.{80}' \
	in_vc_files='Makefile\.am' \
	halt='Wrap long lines in Makefiles' \
742
	  $(_sc_search_regexp)
E
Eric Blake 已提交
743

744
sc_copyright_format:
745 746 747
	@require='Copyright .*Red 'Hat', Inc\.' \
	containing='Copyright .*Red 'Hat \
	halt='Red Hat copyright is missing Inc.' \
748
	  $(_sc_search_regexp)
749 750
	@prohibit='Copyright [^(].*Red 'Hat \
	halt='consistently use (C) in Red Hat copyright' \
751
	  $(_sc_search_regexp)
752 753
	@prohibit='\<RedHat\>' \
	halt='spell Red Hat as two words' \
E
Eric Blake 已提交
754
	  $(_sc_search_regexp)
755

756
# Prefer the new URL listing over the old street address listing when
757 758 759 760 761 762
# calling out where to get a copy of the [L]GPL.  Also, while we have
# to ship COPYING (GPL) alongside COPYING.LESSER (LGPL), we want any
# source file that calls out a top-level file to call out the LGPL
# version.  Note that our typical copyright boilerplate refers to the
# license by name, not by reference to a top-level file.
sc_copyright_usage:
763 764
	@prohibit=Boston,' MA' \
	halt='Point to <http://www.gnu.org/licenses/>, not an address' \
765
	  $(_sc_search_regexp)
766 767 768
	@require='COPYING\.LESSER' \
	containing='COPYING' \
	halt='Refer to COPYING.LESSER for LGPL' \
769
	  $(_sc_search_regexp)
770 771
	@prohibit='COPYING\.LIB' \
	halt='Refer to COPYING.LESSER for LGPL' \
772
	  $(_sc_search_regexp)
773

774 775 776
# Some functions/macros produce messages intended solely for developers
# and maintainers.  Do not mark them for translation.
sc_prohibit_gettext_markup:
777 778
	@prohibit='\<VIR_(WARN|INFO|DEBUG) *\(_\(' \
	halt='do not mark these strings for translation' \
779
	  $(_sc_search_regexp)
780

E
Eric Blake 已提交
781 782 783 784
# Our code is divided into modular subdirectories for a reason, and
# lower-level code must not include higher-level headers.
cross_dirs=$(patsubst $(srcdir)/src/%.,%,$(wildcard $(srcdir)/src/*/.))
cross_dirs_re=($(subst / ,/|,$(cross_dirs)))
785
mid_dirs=access|admin|conf|cpu|locking|logging|rpc|security
E
Eric Blake 已提交
786
sc_prohibit_cross_inclusion:
787 788 789 790
	@for dir in $(cross_dirs); do \
	  case $$dir in \
	    util/) safe="util";; \
	    access/ | conf/) safe="($$dir|conf|util)";; \
791
	    cpu/| network/| node_device/| rpc/| security/| storage/) \
792 793 794 795 796 797 798 799 800
	      safe="($$dir|util|conf|storage)";; \
	    xenapi/ | xenconfig/ ) safe="($$dir|util|conf|xen|cpu)";; \
	    *) safe="($$dir|$(mid_dirs)|util)";; \
	  esac; \
	  in_vc_files="^src/$$dir" \
	  prohibit='^# *include .$(cross_dirs_re)' \
	  exclude="# *include .$$safe" \
	  halt='unsafe cross-directory include' \
	    $(_sc_search_regexp) \
E
Eric Blake 已提交
801 802
	done

E
Eric Blake 已提交
803 804 805
# When converting an enum to a string, make sure that we track any new
# elements added to the enum by using a _LAST marker.
sc_require_enum_last_marker:
806 807 808 809 810 811
	@grep -A1 -nE '^[^#]*VIR_ENUM_IMPL *\(' $$($(VC_LIST_EXCEPT)) \
	   | $(SED) -ne '/VIR_ENUM_IMPL[^,]*,$$/N' \
	     -e '/VIR_ENUM_IMPL[^,]*,[^,]*[^_,][^L,][^A,][^S,][^T,],/p' \
	     -e '/VIR_ENUM_IMPL[^,]*,[^,]\{0,4\},/p' \
	   | grep . && \
	  { echo '$(ME): enum impl needs to use _LAST marker' 1>&2; \
E
Eric Blake 已提交
812 813
	    exit 1; } || :

814 815
# In Python files we don't want to end lines with a semicolon like in C
sc_prohibit_semicolon_at_eol_in_python:
816 817 818
	@prohibit='^[^#].*\;$$' \
	in_vc_files='\.py$$' \
	halt='python does not require to end lines with a semicolon' \
819 820
	  $(_sc_search_regexp)

821 822
# mymain() in test files should use return, not exit, for nicer output
sc_prohibit_exit_in_tests:
823 824 825
	@prohibit='\<exit *\(' \
	in_vc_files='tests/.*\.c$$' \
	halt='use return, not exit(), in tests' \
826 827
	  $(_sc_search_regexp)

828
# Don't include "libvirt/*.h" in "" form.
829
sc_prohibit_include_public_headers_quote:
830 831 832
	@prohibit='# *include *"libvirt/.*\.h"' \
	in_vc_files='\.[ch]$$' \
	halt='Do not include libvirt/*.h in internal source' \
833 834 835 836 837
	  $(_sc_search_regexp)

# Don't include "libvirt/*.h" in <> form. Except for external tools,
# e.g. Python binding, examples and tools subdirectories.
sc_prohibit_include_public_headers_brackets:
838 839 840
	@prohibit='# *include *<libvirt/.*\.h>' \
	in_vc_files='\.[ch]$$' \
	halt='Do not include libvirt/*.h in internal source' \
841 842
	  $(_sc_search_regexp)

843 844 845
# <config.h> is only needed in .c files; .h files do not need it since
# .c files must include config.h before any other .h.
sc_prohibit_config_h_in_headers:
846 847 848
	@prohibit='^# *include\>.*config\.h' \
	in_vc_files='\.h$$' \
	halt='headers should not include <config.h>' \
849 850
	  $(_sc_search_regexp)

851
sc_prohibit_unbounded_arrays_in_rpc:
852 853 854
	@prohibit='<>' \
	in_vc_files='\.x$$' \
	halt='Arrays in XDR must have a upper limit set for <NNN>' \
855 856
	  $(_sc_search_regexp)

857
sc_prohibit_getenv:
858 859 860
	@prohibit='\b(secure_)?getenv *\(' \
	exclude='exempt from syntax-check' \
	halt='Use virGetEnv{Allow,Block}SUID instead of getenv' \
861
	  $(_sc_search_regexp)
862

P
Peter Krempa 已提交
863
sc_prohibit_atoi:
864
	@prohibit='\bato(i|f|l|ll|q) *\(' \
P
Peter Krempa 已提交
865 866 867
	halt='Use virStrToLong* instead of atoi, atol, atof, atoq, atoll' \
	  $(_sc_search_regexp)

868
sc_prohibit_wrong_filename_in_comment:
869 870 871 872
	@fail=0; \
	awk 'BEGIN { \
	  fail=0; \
	} FNR < 3 { \
873
	  n=match($$0, /[[:space:]][^[:space:]]*[.][ch][[:space:]:]/); \
874 875 876 877 878 879 880 881 882 883 884 885 886 887 888 889
	  if (n > 0) { \
	    A=substr($$0, RSTART+1, RLENGTH-2); \
	    n=split(FILENAME, arr, "/"); \
	    if (A != arr[n]) { \
	      print "in " FILENAME ": " A " mentioned in comments "; \
	      fail=1; \
	    } \
	  } \
	} END { \
	  if (fail == 1) { \
	    exit 1; \
	  } \
	}' $$($(VC_LIST_EXCEPT) | grep '\.[ch]$$') || fail=1; \
	if test $$fail -eq 1; then \
	  { echo '$(ME): The file name in comments must match the' \
	    'actual file name' 1>&2; exit 1; } \
890 891
	fi;

892
sc_prohibit_virConnectOpen_in_virsh:
893 894 895
	@prohibit='\bvirConnectOpen[a-zA-Z]* *\(' \
	in_vc_files='tools/virsh-.*\.[ch]$$' \
	halt='Use vshConnect() in virsh instead of virConnectOpen*' \
896 897
	  $(_sc_search_regexp)

J
Ján Tomko 已提交
898
sc_require_space_before_label:
899 900 901
	@prohibit='^(   ?)?[_a-zA-Z0-9]+:$$' \
	in_vc_files='\.[ch]$$' \
	halt='Top-level labels should be indented by one space' \
J
Ján Tomko 已提交
902 903
	  $(_sc_search_regexp)

904 905 906 907
# Allow for up to three spaces before the label: this is to avoid running
# into situations where neither this rule nor require_space_before_label
# would apply, eg. a line matching ^[a-zA-Z0-9]+ :$
sc_prohibit_space_in_label:
908 909 910
	@prohibit='^ {0,3}[_a-zA-Z0-9]+ +:$$' \
	in_vc_files='\.[ch]$$' \
	halt='There should be no space between label name and colon' \
911 912
	  $(_sc_search_regexp)

913 914
# Doesn't catch all cases of mismatched braces across if-else, but it helps
sc_require_if_else_matching_braces:
915 916 917
	@prohibit='(  else( if .*\))? {|} else( if .*\))?$$)' \
	in_vc_files='\.[chx]$$' \
	halt='if one side of if-else uses {}, both sides must use it' \
918 919
	  $(_sc_search_regexp)

920
sc_curly_braces_style:
921 922 923 924 925 926 927
	@files=$$($(VC_LIST_EXCEPT) | grep '\.[ch]$$'); \
	if $(GREP) -nHP \
'^\s*(?!([a-zA-Z_]*for_?each[a-zA-Z_]*) ?\()([_a-zA-Z0-9]+( [_a-zA-Z0-9]+)* ?\()?(\*?[_a-zA-Z0-9]+(,? \*?[_a-zA-Z0-9\[\]]+)+|void)\) ?\{' \
	$$files; then \
	  echo '$(ME): Non-K&R style used for curly braces around' \
	    'function body' 1>&2; exit 1; \
	fi; \
928
	if $(GREP) -A1 -En ' ((if|for|while|switch) \(|(else|do)\b)[^{]*$$'\
929
	  $$files | $(GREP) '^[^ ]*- *{'; then \
930
	  echo '$(ME): Use hanging braces for compound statements' 1>&2; exit 1; \
931
	fi
P
Peter Krempa 已提交
932

933
sc_prohibit_windows_special_chars_in_filename:
934 935
	@files=$$($(VC_LIST_EXCEPT) | grep '[:*?"<>|]'); \
	test -n "$$files" && { echo '$(ME): Windows special chars' \
936 937
	  'in filename not allowed:' 1>&2; echo $$files 1>&2; exit 1; } || :

938
sc_prohibit_mixed_case_abbreviations:
939 940 941
	@prohibit='Pci|Usb|Scsi' \
	in_vc_files='\.[ch]$$' \
	halt='Use PCI, USB, SCSI, not Pci, Usb, Scsi' \
942 943
	  $(_sc_search_regexp)

944 945
# Require #include <locale.h> in all files that call setlocale()
sc_require_locale_h:
946 947 948
	@require='include.*locale\.h' \
	containing='setlocale *(' \
	halt='setlocale() requires <locale.h>' \
949
	  $(_sc_search_regexp)
950

951
sc_prohibit_empty_first_line:
952 953 954 955
	@awk 'BEGIN { fail=0; } \
	FNR == 1 { if ($$0 == "") { print FILENAME ":1:"; fail=1; } } \
	END { if (fail == 1) { \
	  print "$(ME): Prohibited empty first line" > "/dev/stderr"; \
956 957
	} exit fail; }' $$($(VC_LIST_EXCEPT));

958
sc_prohibit_paren_brace:
959 960 961
	@prohibit='\)\{$$' \
	in_vc_files='\.[chx]$$' \
	halt='Put space between closing parenthesis and opening brace' \
962 963
	  $(_sc_search_regexp)

964 965 966
# C guarantees that static variables are zero initialized, and some compilers
# waste space by sticking explicit initializers in .data instead of .bss
sc_prohibit_static_zero_init:
967 968
	@prohibit='\bstatic\b.*= *(0[^xX0-9]|NULL|false)' \
	in_vc_files='\.[chx](\.in)?$$' \
969 970 971
	halt='static variables do not need explicit zero initialization'\
	  $(_sc_search_regexp)

972 973
# FreeBSD exports the "devname" symbol which produces a warning.
sc_prohibit_devname:
974
	@prohibit='\bdevname\b' \
975
	exclude='sc_prohibit_devname' \
976
	halt='avoid using devname as FreeBSD exports the symbol' \
977 978
	  $(_sc_search_regexp)

J
Jiri Denemark 已提交
979 980 981 982 983
sc_prohibit_system_error_with_vir_err:
	@prohibit='\bvirReportSystemError *\(VIR_ERR_' \
	halt='do not use virReportSystemError with VIR_ERR_* error codes' \
	  $(_sc_search_regexp)

984 985 986 987
# Rule to prohibit usage of virXXXFree within library, daemon, remote, etc.
# functions. There's a corresponding exclude to allow usage within tests,
# docs, examples, tools, src/libvirt-*.c, and include/libvirt/libvirt-*.h
sc_prohibit_virXXXFree:
988
	@prohibit='\bvir(Domain|Network|NodeDevice|StorageVol|StoragePool|Stream|Secret|NWFilter|Interface|DomainSnapshot)Free\b' \
989
	exclude='sc_prohibit_virXXXFree' \
990
	halt='avoid using virXXXFree, use virObjectUnref instead' \
991 992
	  $(_sc_search_regexp)

993 994 995 996 997
sc_prohibit_sysconf_pagesize:
	@prohibit='sysconf\(_SC_PAGESIZE' \
	halt='use virGetSystemPageSize[KB] instead of sysconf(_SC_PAGESIZE)' \
	  $(_sc_search_regexp)

998
sc_prohibit_virSecurity:
999 1000
	@grep -Pn 'virSecurityManager(?!Ptr)' $$($(VC_LIST_EXCEPT) | grep 'src/qemu/' | \
		grep -v 'src/qemu/qemu_security') && \
1001 1002
		{ echo '$(ME): prefer qemuSecurity wrappers' 1>&2; exit 1; } || :

J
Jiri Denemark 已提交
1003 1004 1005
sc_prohibit_pthread_create:
	@prohibit='\bpthread_create\b' \
	exclude='sc_prohibit_pthread_create' \
1006
	halt='avoid using pthread_create, use virThreadCreate instead' \
J
Jiri Denemark 已提交
1007 1008
	  $(_sc_search_regexp)

1009
sc_prohibit_not_streq:
1010 1011
	@prohibit='! *STRN?EQ *\(.*\)' \
	halt='Use STRNEQ instead of !STREQ and STREQ instead of !STRNEQ' \
1012 1013
	  $(_sc_search_regexp)

J
Ján Tomko 已提交
1014
sc_prohibit_verbose_strcat:
1015 1016
	@prohibit='strncat\([^,]*,\s+([^,]*),\s+strlen\(\1\)\)' \
	in_vc_files='\.[ch]$$' \
J
Ján Tomko 已提交
1017 1018 1019
	halt='Use strcat(a, b) instead of strncat(a, b, strlen(b))' \
	  $(_sc_search_regexp)

1020 1021 1022
# Ensure that each .c file containing a "main" function also
# calls virGettextInitialize
sc_gettext_init:
1023 1024 1025 1026
	@require='virGettextInitialize *\(' \
	in_vc_files='\.c$$' \
	containing='\<main *(' \
	halt='the above files do not call virGettextInitialize' \
1027 1028
	  $(_sc_search_regexp)

1029
sc_prohibit_obj_free_apis_in_virsh:
1030
	@prohibit='\bvir(Domain|DomainSnapshot)Free\b' \
1031
	in_vc_files='virsh.*\.[ch]$$' \
1032
	exclude='sc_prohibit_obj_free_apis_in_virsh' \
1033
	halt='avoid using virDomain(Snapshot)Free in virsh, use virsh-prefixed wrappers instead' \
1034 1035
	  $(_sc_search_regexp)

1036 1037 1038 1039 1040 1041 1042 1043 1044 1045 1046 1047 1048 1049 1050 1051 1052
https_sites = www.libvirt.org
https_sites += libvirt.org
https_sites += security.libvirt.org
https_sites += qemu.org
https_sites += www.qemu.org
https_sites += wiki.qemu.org
https_sites += linux-kvm.org
https_sites += www.linux-kvm.org

https_re= ($(subst $(space),|,$(https_sites)))

sc_prohibit_http_urls:
	@prohibit='http://$(https_re)' \
	exclude="/schemas/" \
	halt='Links must use https:// protocol' \
	  $(_sc_search_regexp)

1053 1054 1055 1056 1057
sc_prohibit_author:
	@prohibit="(\*|#)\s*(A|a)uthors?:" \
	halt="Author: statements are prohibited in source comments" \
	  $(_sc_search_regexp)

1058 1059
# Alignment is usually achieved through spaces (at least two of them)
# or tabs (at least one of them) right before the trailing backslash
1060
sc_prohibit_backslash_alignment:
1061
	@prohibit='(  |	)\\$$' \
1062 1063 1064 1065
	in_vc_files='*\.([chx]|am|mk)$$' \
	halt='Do not attempt to right-align backslashes' \
	  $(_sc_search_regexp)

1066 1067 1068 1069 1070 1071
# Some syntax rules pertaining to the usage of cleanup macros
# implementing GNU C's cleanup attribute

# Rule to ensure that varibales declared using a cleanup macro are
# always initialized.
sc_require_attribute_cleanup_initialization:
1072
	@prohibit='VIR_AUTO((FREE|PTR)\(.+\)|CLOSE) *[^=]+;' \
1073 1074 1075 1076
	in_vc_files='\.[chx]$$' \
	halt='variable declared with a cleanup macro must be initialized' \
	  $(_sc_search_regexp)

1077 1078
# We don't use this feature of maint.mk.
prev_version_file = /dev/null
1079

1080
ifneq ($(_gl-Makefile),)
1081
ifeq (0,$(MAKELEVEL))
1082 1083 1084 1085 1086 1087
  _dry_run_result := $(shell \
      cd '$(srcdir)'; \
      test -d .git || test -f .git || { echo 0; exit; }; \
      $(srcdir)/autogen.sh --dry-run >/dev/null 2>&1; \
      echo $$?; \
  )
1088
  _clean_requested = $(filter %clean,$(MAKECMDGOALS))
1089 1090 1091 1092 1093 1094 1095 1096 1097 1098 1099 1100 1101 1102 1103 1104 1105

  # A return value of 0 means no action is required

  # A return value of 1 means a genuine error has occurred while
  # performing the dry run, and it should be reported so it can
  # be investigated
  ifeq (1,$(_dry_run_result))
    $(info INFO: autogen.sh error, running again to show details)
maint.mk Makefile: _autogen_error
  endif

  # A return value of 2 means that autogen.sh needs to be executed
  # in earnest before building, probably because of gnulib updates.
  # We don't run autogen.sh if the clean target has been invoked,
  # though, as it would be quite pointless
  ifeq (2,$(_dry_run_result)$(_clean_requested))
    $(info INFO: running autogen.sh is required, running it now...)
C
Cole Robinson 已提交
1106
    $(shell touch $(srcdir)/AUTHORS $(srcdir)/ChangeLog)
E
Eric Blake 已提交
1107
maint.mk Makefile: _autogen
1108 1109
  endif
endif
1110
endif
1111

E
Eric Blake 已提交
1112 1113 1114 1115 1116 1117 1118
# It is necessary to call autogen any time gnulib changes.  Autogen
# reruns configure, then we regenerate all Makefiles at once.
.PHONY: _autogen
_autogen:
	$(srcdir)/autogen.sh
	./config.status

1119 1120 1121 1122
.PHONY: _autogen_error
_autogen_error:
	$(srcdir)/autogen.sh --dry-run

1123
ifneq ($(_gl-Makefile),)
1124
syntax-check: spacing-check test-wrap-argv \
1125 1126
	prohibit-duplicate-header mock-noinline group-qemu-caps \
        header-ifdef
1127
endif
1128

1129 1130 1131 1132 1133
# Don't include duplicate header in the source (either *.c or *.h)
prohibit-duplicate-header:
	$(AM_V_GEN)files=$$($(VC_LIST_EXCEPT) | grep '\.[chx]$$'); \
	$(PERL) -W $(top_srcdir)/build-aux/prohibit-duplicate-header.pl $$files

1134
spacing-check:
1135
	$(AM_V_GEN)files=`$(VC_LIST) | grep '\.c$$'`; \
1136
	$(PERL) $(top_srcdir)/build-aux/check-spacing.pl $$files || \
1137
	  { echo '$(ME): incorrect formatting' 1>&2; exit 1; }
1138

1139 1140 1141 1142
mock-noinline:
	$(AM_V_GEN)files=`$(VC_LIST) | grep '\.[ch]$$'`; \
	$(PERL) $(top_srcdir)/build-aux/mock-noinline.pl $$files

1143 1144 1145 1146
header-ifdef:
	$(AM_V_GEN)files=`$(VC_LIST) | grep '\.[h]$$'`; \
	$(PERL) $(top_srcdir)/build-aux/header-ifdef.pl $$files

1147 1148
test-wrap-argv:
	$(AM_V_GEN)files=`$(VC_LIST) | grep -E '\.(ldargs|args)'`; \
1149
	$(PERL) $(top_srcdir)/tests/test-wrap-argv.pl --check $$files
1150

1151
group-qemu-caps:
1152
	$(AM_V_GEN)$(PERL) $(top_srcdir)/tests/group-qemu-caps.pl --check $(top_srcdir)/
1153

1154
# sc_po_check can fail if generated files are not built first
1155
sc_po_check: \
1156 1157
		$(srcdir)/src/remote/remote_daemon_dispatch_stubs.h \
		$(srcdir)/src/remote/remote_daemon_dispatch_qemu_stubs.h \
1158
		$(srcdir)/src/remote/remote_client_bodies.h \
1159
		$(srcdir)/src/admin/admin_server_dispatch_stubs.h \
1160
		$(srcdir)/src/admin/admin_client.h
1161 1162 1163 1164
$(srcdir)/src/remote/remote_daemon_dispatch_stubs.h: $(srcdir)/src/remote/remote_protocol.x
	$(MAKE) -C src remote/remote_daemon_dispatch_stubs.h
$(srcdir)/src/remote/remote_daemon_dispatch_qemu_stubs.h: $(srcdir)/src/remote/qemu_protocol.x
	$(MAKE) -C src remote/remote_daemon_dispatch_qemu_stubs.h
1165
$(srcdir)/src/remote/remote_client_bodies.h: $(srcdir)/src/remote/remote_protocol.x
1166
	$(MAKE) -C src remote/remote_client_bodies.h
1167 1168
$(srcdir)/src/admin/admin_server_dispatch_stubs.h: $(srcdir)/src/admin/admin_protocol.x
	$(MAKE) -C src admin/admin_server_dispatch_stubs.h
1169 1170
$(srcdir)/src/admin/admin_client.h: $(srcdir)/src/admin/admin_protocol.x
	$(MAKE) -C src admin/admin_client.h
1171

1172
# List all syntax-check exemptions:
1173
exclude_file_name_regexp--sc_avoid_strcase = ^tools/vsh\.h$$
1174

1175
_src1=libvirt-stream|qemu/qemu_monitor|util/vir(command|file|fdstream)|xen/xend_internal|rpc/virnetsocket|lxc/lxc_controller|locking/lock_daemon|logging/log_daemon
1176
_test1=shunloadtest|virnettlscontexttest|virnettlssessiontest|vircgroupmock|commandhelper
1177
exclude_file_name_regexp--sc_avoid_write = \
1178
  ^(src/($(_src1))|tools/virsh-console|tests/($(_test1)))\.c$$
1179

1180 1181 1182
exclude_file_name_regexp--sc_bindtextdomain = .*

exclude_file_name_regexp--sc_gettext_init = ^(tests|examples)/
1183

1184 1185 1186
exclude_file_name_regexp--sc_copyright_format = \
	^cfg\.mk$$

1187
exclude_file_name_regexp--sc_copyright_usage = \
1188
  ^COPYING(|\.LESSER)$$
1189

1190
exclude_file_name_regexp--sc_flags_usage = \
1191
  ^(cfg\.mk|docs/|src/util/virnetdevtap\.c$$|tests/((vir(cgroup|pci|test|usb)|nss|qemuxml2argv|qemusecurity)mock|virfilewrapper)\.c$$)
1192

1193
exclude_file_name_regexp--sc_libvirt_unmarked_diagnostics = \
1194
  ^(src/rpc/gendispatch\.pl$$|tests/)
1195

1196
exclude_file_name_regexp--sc_po_check = ^(docs/|src/rpc/gendispatch\.pl$$)
1197 1198

exclude_file_name_regexp--sc_prohibit_VIR_ERR_NO_MEMORY = \
1199
  ^(cfg\.mk|include/libvirt/virterror\.h|src/remote/remote_daemon_dispatch\.c|src/util/virerror\.c|docs/internals/oomtesting\.html\.in)$$
1200 1201 1202

exclude_file_name_regexp--sc_prohibit_PATH_MAX = \
	^cfg\.mk$$
1203

1204 1205
exclude_file_name_regexp--sc_prohibit_access_xok = \
	^(cfg\.mk|src/util/virutil\.c)$$
E
Eric Blake 已提交
1206

1207
exclude_file_name_regexp--sc_prohibit_asprintf = \
1208
  ^(cfg\.mk|bootstrap.conf$$|examples/|src/util/virstring\.[ch]$$|tests/vircgroupmock\.c$$)
E
Eric Blake 已提交
1209

1210
exclude_file_name_regexp--sc_prohibit_strdup = \
1211
  ^(docs/|examples/|src/util/virstring\.c|tests/vir(netserverclient|cgroup)mock.c|tests/commandhelper\.c$$)
1212

1213
exclude_file_name_regexp--sc_prohibit_close = \
1214
  (\.p[yl]$$|\.spec\.in$$|^docs/|^(src/util/virfile\.c|src/libvirt-stream\.c|tests/(vir.+mock\.c|commandhelper\.c|qemusecuritymock\.c))$$)
1215 1216

exclude_file_name_regexp--sc_prohibit_empty_lines_at_EOF = \
J
Ján Tomko 已提交
1217
  (^tests/(virhostcpu|virpcitest)data/|docs/js/.*\.js|docs/fonts/.*\.woff|\.diff|tests/virconfdata/no-newline\.conf$$)
1218

1219
_src2=src/(util/vircommand|libvirt|lxc/lxc_controller|locking/lock_daemon|logging/log_daemon|remote/remote_daemon)
1220
exclude_file_name_regexp--sc_prohibit_fork_wrappers = \
1221
  (^($(_src2)|tests/testutils)\.c$$)
1222

1223
exclude_file_name_regexp--sc_prohibit_gethostname = ^src/util/vir(util|log)\.c$$
1224

E
Eric Blake 已提交
1225
exclude_file_name_regexp--sc_prohibit_internal_functions = \
1226
  ^src/(util/(viralloc|virutil|virfile)\.[hc]|esx/esx_vi\.c)$$
E
Eric Blake 已提交
1227

1228 1229 1230
exclude_file_name_regexp--sc_prohibit_raw_virclassnew = \
  ^src/util/virobject\.[hc]$$

1231
exclude_file_name_regexp--sc_prohibit_newline_at_end_of_diagnostic = \
1232
  ^src/rpc/gendispatch\.pl$$
1233

1234
exclude_file_name_regexp--sc_prohibit_nonreentrant = \
1235
  ^((po|tests)/|docs/.*(py|js|html\.in)|run.in$$|tools/wireshark/util/genxdrstub\.pl$$)
1236

1237 1238 1239
exclude_file_name_regexp--sc_prohibit_select = \
	^cfg\.mk$$

1240
exclude_file_name_regexp--sc_prohibit_canonicalize_file_name = \
1241
  ^(cfg\.mk|tests/virfilemock\.c)$$
1242

E
Eric Blake 已提交
1243
exclude_file_name_regexp--sc_prohibit_raw_allocation = \
1244
  ^(docs/hacking\.html\.in|src/util/viralloc\.[ch]|examples/.*|tests/(securityselinuxhelper|(vircgroup|nss)mock|commandhelper)\.c|tools/wireshark/src/packet-libvirt\.c)$$
E
Eric Blake 已提交
1245

1246
exclude_file_name_regexp--sc_prohibit_readlink = \
1247
  ^src/(util/virutil|lxc/lxc_container)\.c$$
1248

1249
exclude_file_name_regexp--sc_prohibit_setuid = ^src/util/virutil\.c$$
E
Eric Blake 已提交
1250

1251
exclude_file_name_regexp--sc_prohibit_sprintf = \
1252
  ^(cfg\.mk|docs/hacking\.html\.in|.*\.stp|.*\.pl)$$
1253

1254
exclude_file_name_regexp--sc_prohibit_strncpy = ^src/util/virstring\.c$$
1255

1256
exclude_file_name_regexp--sc_prohibit_strtol = ^examples/.*$$
E
Eric Blake 已提交
1257

1258
exclude_file_name_regexp--sc_prohibit_xmlGetProp = ^src/util/virxml\.c$$
1259

M
Martin Kletzander 已提交
1260 1261
exclude_file_name_regexp--sc_prohibit_xmlURI = ^src/util/viruri\.c$$

1262 1263
exclude_file_name_regexp--sc_prohibit_return_as_function = \.py$$

1264 1265
exclude_file_name_regexp--sc_require_config_h = \
	^(examples/|tools/virsh-edit\.c$$)
1266

1267 1268
exclude_file_name_regexp--sc_require_config_h_first = \
	^(examples/|tools/virsh-edit\.c$$)
1269

1270
exclude_file_name_regexp--sc_trailing_blank = \
J
Ján Tomko 已提交
1271
  /sysinfodata/.*\.data|/virhostcpudata/.*\.cpuinfo|^gnulib/local/.*/.*diff$$
1272 1273

exclude_file_name_regexp--sc_unmarked_diagnostics = \
1274
  ^(docs/apibuild.py|tests/virt-aa-helper-test|docs/js/.*\.js)$$
1275 1276

exclude_file_name_regexp--sc_size_of_brackets = cfg.mk
1277 1278 1279

exclude_file_name_regexp--sc_correct_id_types = \
  (^src/locking/lock_protocol.x$$)
1280 1281

exclude_file_name_regexp--sc_m4_quote_check = m4/virt-lib.m4
1282

1283
exclude_file_name_regexp--sc_prohibit_include_public_headers_quote = \
1284
  ^(src/internal\.h$$|tools/wireshark/src/packet-libvirt.h$$)
1285 1286

exclude_file_name_regexp--sc_prohibit_include_public_headers_brackets = \
1287
  ^(tools/|examples/|include/libvirt/(virterror|libvirt(-(admin|qemu|lxc))?)\.h$$)
1288 1289

exclude_file_name_regexp--sc_prohibit_int_ijk = \
1290
  ^(src/remote_protocol-structs|src/remote/remote_protocol\.x|cfg\.mk|include/libvirt/libvirt.+|src/admin_protocol-structs|src/admin/admin_protocol\.x)$$
1291

M
Michal Privoznik 已提交
1292 1293 1294
exclude_file_name_regexp--sc_prohibit_unsigned_pid = \
  ^(include/libvirt/.*\.h|src/(qemu/qemu_driver\.c|driver-hypervisor\.h|libvirt(-[a-z]*)?\.c|.*\.x|util/vir(polkit|systemd)\.c)|tests/virpolkittest\.c|tools/virsh-domain\.c)$$

1295 1296
exclude_file_name_regexp--sc_prohibit_getenv = \
  ^tests/.*\.[ch]$$
1297 1298

exclude_file_name_regexp--sc_avoid_attribute_unused_in_header = \
M
Martin Kletzander 已提交
1299
  ^(src/util/virlog\.h|src/network/bridge_driver\.h)$$
1300 1301 1302

exclude_file_name_regexp--sc_prohibit_mixed_case_abbreviations = \
  ^src/(vbox/vbox_CAPI.*.h|esx/esx_vi.(c|h)|esx/esx_storage_backend_iscsi.c)$$
1303 1304

exclude_file_name_regexp--sc_prohibit_empty_first_line = \
1305
  ^(README|src/esx/README|tests/(vmwarever|virhostcpu)data/.*)$$
1306 1307 1308

exclude_file_name_regexp--sc_prohibit_useless_translation = \
  ^tests/virpolkittest.c
1309 1310 1311

exclude_file_name_regexp--sc_prohibit_devname = \
  ^(tools/virsh.pod|cfg.mk|docs/.*)$$
1312 1313

exclude_file_name_regexp--sc_prohibit_virXXXFree = \
1314
  ^(docs/|tests/|examples/|tools/|cfg.mk|src/test/test_driver.c|src/libvirt_public.syms|include/libvirt/libvirt-(domain|network|nodedev|storage|stream|secret|nwfilter|interface|domain-snapshot).h|src/libvirt-(domain|qemu|network|nodedev|storage|stream|secret|nwfilter|interface|domain-snapshot).c$$)
1315 1316 1317

exclude_file_name_regexp--sc_prohibit_sysconf_pagesize = \
  ^(cfg\.mk|src/util/virutil\.c)$$
J
Jiri Denemark 已提交
1318 1319 1320

exclude_file_name_regexp--sc_prohibit_pthread_create = \
  ^(cfg\.mk|src/util/virthread\.c|tests/.*)$$
1321

1322 1323
exclude_file_name_regexp--sc_prohibit_always-defined_macros = \
  ^tests/virtestmock.c$$
J
Ján Tomko 已提交
1324 1325

exclude_file_name_regexp--sc_prohibit_readdir = \
1326
  ^tests/(.*mock|virfilewrapper)\.c$$
1327 1328 1329

exclude_file_name_regexp--sc_prohibit_cross_inclusion = \
  ^(src/util/virclosecallbacks\.h|src/util/virhostdev\.h)$$